<?php
/*
============================================================
TS_Backup Plugin for CMSimple_XH - based on:
============================================================
Version:    v1.0 beta3
Released:   24th October 2008
Copyright:  Tillman Schuster
Email:      tischuster@nmud.de
Website:    www.nmud.de
============================================================
Modified by: www.ge-webdesign.de 2009/08
============================================================
*/
// Unterbindet direkten Aufruf. Das Script darf nur als Include durch Pluginloader laufen. (So etwas in der Art sollte immer in einer Include-Datei stehen!!!). 
if ((!function_exists('sv')) || eregi($pth['folder']['plugins'].$plugin.'/admin.php', sv('PHP_SELF')))die('Access denied');

// Eine nicht vorhandene CMSimple-Funktion 'initvar' wrde einen Fatal_Error bei direktem Aufruf angeben und das Script sofort beenden (doppelter Schutz).
initvar("ts_backup");

if ($ts_backup) {

	// Variable
    global $pth, $plugin_tx, $plugin, $zipdownload;
    $plugin = basename(dirname(__FILE__), "/");
    $zipdownload = basename($_SERVER['__FILE__']);
    $start = $_POST['downloadnow'];
    
	// Plugin Admin Men-Funktionen
	$action = isset ($_GET['action']) ? $_GET['action'] : "";
    $action .= isset ($_POST['action']) ? $_POST['action'] : "";
	$o .= print_plugin_admin("OFF");
	if ($admin <> "plugin_main") {
        $hint = ARRAY ();
        $hint['mode_donotshowvarnames'] = true;
        $o .= plugin_admin_common($action, $admin, $plugin, $hint);
    } 

// ruft Funktion zur Bildung und Abschicken vom ZIP		
if (isset($start)) {
        form_ZIP();
    } 
	// Formularaufruf
    if ($action == "" OR $action != "plugin_edit") {
        $o .= tag("br");
        $o .= "TS_Backup Plugin for <b>CMSimple_XH</b> - based on:";
        $o .= tag("hr");
        $o .= "Version: v1.0 beta3" . tag('br');
        $o .= "Released: 24th October 2008" . tag('br');
        $o .= "Copyright: Tillman Schuster" . tag('br');
        $o .= "Email: <a href=\"mailto:tischuster@nmud.de\">tischuster@nmud.de</a>";
        $o .= tag("br");
        $o .= "Website: <a href=\"http://www.nmud.de\">www.nmud.de</a>";
        $o .= tag("hr");
        $o .= "Modified for <b>CMSimple_XH</b> by: <a href=\"http://www.ge-webdesign.de\">www.ge-webdesign.de</a> 2009/08";
        $o .= tag("br");
        $o .= tag("hr");
        $o .= tag("br");
        $o .= "<b>" . $plugin_tx['ts_backup']['Message_Text1'] . "</b>";
        $o .= tag("br");
        $o .= "(" . $plugin_tx['ts_backup']['Message_Text2'] . ")</span>";
        $o .= tag("br");
        $o .= tag("br");
        $o .= "<form method=\"POST\" action=\"" . $zipdownload . "\">";
        $o .= tag("input name=\"checkbx[]\" type=\"checkbox\" value=\"../../" . $pth['file']['content'] . "\"" . "checked") ."&nbsp;". $plugin_tx['ts_backup']['files_Content_File'] . tag("br");
        if (file_exists($pth['folder']['content'].'pagedata.php')) {
			$o .= tag("input name=\"checkbx[]\" type=\"checkbox\" value=\"../../" . $pth['file']['pagedata'] . "\"" . "checked") ."&nbsp;". $plugin_tx['ts_backup']['files_Pagedata_File'] . tag("br");
			}
        $o .= tag("input name=\"checkbx[]\" type=\"checkbox\" value=\"../../" . $pth['file']['config'] . "\"") ."&nbsp;". $plugin_tx['ts_backup']['files_CMSimple_Configuration'] . tag("br");
        $o .= tag("input name=\"checkbx[]\" type=\"checkbox\" value=\"../../" . $pth['file']['template'] . "\"") ."&nbsp;". $plugin_tx['ts_backup']['files_Template_File'] . tag("br");
        $o .= tag("input name=\"checkbx[]\" type=\"checkbox\" value=\"../../" . $pth['file']['stylesheet'] . "\"") ."&nbsp;". $plugin_tx['ts_backup']['files_Styleysheet_File'] . tag("br") . tag("br");
        $o .= tag("input type=\"submit\" name=\"downloadnow\" value=\"" . $plugin_tx['ts_backup']['button_download'] . "\"");
        $o .= "</form>";
        $o .= tag("br");
    } 
} 
// Funktion zur Bildung und Abschicken vom ZIP
function form_ZIP()
{
    global $filename;
    $action;

	// Zip Libary einbinden
    require($pth['folder']['plugin'] . "zip.lib.php");

	// neues Zip Objekt erstellen
    $zipfile = new zipfile();

    // Fr jede Datei die in Checkbox bermittelt wurde
    for ($i = 0;$i < count($_POST['checkbx']);$i++) {

        // Dateinamen aus POST ermitteln
        $filename = $_POST['checkbx'][$i];
        $clearfilename = replace_slashes($filename);

        // Datei einlesen
        $handle = fopen ($filename, "r");
        $content = fread ($handle, filesize ($filename));
        fclose ($handle);

        // Datei in Zipfile speichern
        $zipfile->addFile($content, $clearfilename, filemtime($filename));
    }
	// Header fr Download senden
$tsbdate = date("Ymd_");
$tsbtime = date("Hi_");
    header("HTTP/1.1 200 OK");
    header("Content-Type: application/force-download");
    header('Content-Disposition: attachment; filename="'.$tsbdate.$tsbtime.'CMSimple-Backup.zip"');
    header("Content-Transfer-Encoding: binary");

	// Zip File senden
    echo $zipfile->file();
} 

// Funktion zum Entfernen der "path slashes"
function replace_slashes($filename)
{
    global $filename;
    $filename = str_replace("../", '', $filename);
    $filename = str_replace("./", '', $filename);
    $filename = str_replace("..\\", '', $filename);
    $filename = str_replace(".\\", '', $filename);
    $filename = str_replace("\\", '/', $filename);
    return $filename;
} 

?>